#include <Arduino.h>
#include <TM1637Display.h>
// pins
volatile byte signal_pin = 4;
volatile byte pind = 0; // input register D (pins 0-7)
volatile int signalcounter = 0;
volatile int signalcounter_out = 0;
volatile boolean signal, oldsignal;
volatile  int value_to_display = 0;
volatile int cyclecounter = 0;
const int cycle_threshold_180ms = 180;
volatile int counter_180ms = 0;
volatile boolean trigger_180ms = false;

const int speedVals[] = {0, 333,667,1000,1333,1667,2000,2333,2667,3000,3333,3667,4000,4333,4667,5000,5333,5667,6000,6333,6667,7000,7333,7667,8000,8333,8667,9000,9333,9667,10000,10333,10667,11000,11333,11667,12000};

TM1637Display display(2, 3);

void setup() {
  DDRD = B00000000;
  display.setBrightness(0x0f);
  cli();//disable interrupts to set timer1 interrupt
  TCCR1A = 0;// set entire TCCR1A register to 0
  TCCR1B = 0;// same for TCCR1B
  TCNT1  = 0;//initialize counter value to 0   // set timer count for 65536khz increments
  OCR1A = 1999;// = (16*10^6) / (1000*8) - 1
  TCCR1B |= (1 << WGM12); // turn on CTC mode
  TCCR1B |= (1 << CS11);     // Set CS11 bit for 8 prescaler
  TIMSK1 |= (1 << OCIE1A); // enable timer compare interrupt
  sei(); // enable interrupts
}
ISR(TIMER1_COMPA_vect){  // the timer-driven interrupt routine
  pind = PIND;
  signal = (pind & (1 << signal_pin)) > 0;

  if (signal && (! oldsignal))
    signalcounter ++;

  oldsignal = signal;

  if (cyclecounter >= cycle_threshold_180ms) {
    trigger_180ms = true;
    cyclecounter = 0;
    signalcounter_out = signalcounter;
    signalcounter = 0;
  }
  cyclecounter ++;
}

void loop()
{
  if (trigger_180ms) {
    display.showNumberDec(speedVals[signalcounter_out], false, 4, 0);
    trigger_180ms = false;
  }
}